From 04e2d2f5efde8b161cd69b814780a055d1afe77b Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 20/48] convert ModuleComponents etc. to libmodulemd


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index c40c21e..4c8b448 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -767,13 +767,19 @@ class ModuleMetadata(object):
         """A ModuleComponents instance property representing the components
         defining the module.
         """
+        if not hasattr(self, '_components'):
+            self._components = ModuleComponents(parent=self)
+        self._components.rpms = self.module.get_rpm_components()
+        self._components.modules = self.module.get_module_components()
         return self._components
 
     @components.setter
     def components(self, o):
         if not isinstance(o, ModuleComponents):
             raise TypeError("components: data type not supported")
-        self._components = o
+
+        self.module.set_rpm_components(o.rpms)
+        self.module.set_module_components(o.modules)
 
     @property
     def artifacts(self):
diff --git a/modulemd/components/__init__.py b/modulemd/components/__init__.py
index 60ee9a6..b7ef95a 100644
--- a/modulemd/components/__init__.py
+++ b/modulemd/components/__init__.py
@@ -23,18 +23,22 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from gi.repository import Modulemd
+
 from modulemd.components.module import ModuleComponentModule
 from modulemd.components.rpm import ModuleComponentRPM
 
+
 supported_content = ( "rpms", "modules", )
 
 class ModuleComponents(object):
     """Class representing components of a module."""
 
-    def __init__(self):
+    def __init__(self, parent=None):
         """Creates a new ModuleComponents instance."""
-        self.modules = dict()
-        self.rpms = dict()
+        self.parent = parent
+        self._rpms = {}
+        self._modules = {}
 
     def __repr__(self):
         return ("<ModuleComponents: "
@@ -57,6 +61,41 @@ class ModuleComponents(object):
         ac.extend(self.modules.values())
         return ac
 
+    def _save_to_libmodulemd(self):
+        if getattr(self, 'parent', None) is not None:
+            # rpm packages
+            components = {}
+            for name, comp in self._rpms.items():
+                native_comp = Modulemd.ComponentRpm()
+                for attr in ('rationale', 'buildorder', 'repository', 'ref',
+                             'cache', 'arches', 'multilib'):
+                    val = getattr(comp, attr, None)
+                    if val is not None:
+                        if isinstance(val, set):
+                            ss = Modulemd.SimpleSet()
+                            ss.set(tuple(val))
+                            val = ss
+                        getattr(native_comp, 'set_' + attr)(val)
+                components[name] = native_comp
+
+            self.parent.module.set_rpm_components(components)
+
+            # modules
+            components = {}
+            for name, comp in self._modules.items():
+                native_comp = Modulemd.ComponentModule()
+                for attr in ('rationale', 'buildorder', 'repository', 'ref'):
+                    val = getattr(comp, attr, None)
+                    if val is not None:
+                        if isinstance(val, set):
+                            ss = Modulemd.SimpleSet()
+                            ss.set(tuple(val))
+                            val = ss
+                        getattr(native_comp, 'set_' + attr)(val)
+                components[name] = native_comp
+
+            self.parent.module.set_module_components(components)
+
     @property
     def rpms(self):
         """A dictionary of RPM components in this module.  The keys are SRPM
@@ -73,6 +112,8 @@ class ModuleComponents(object):
                 raise TypeError("components.rpms: data type not supported")
         self._rpms = d
 
+        self._save_to_libmodulemd()
+
     def add_rpm(self, name, rationale, buildorder=0,
             repository="", ref="", cache="", arches=set(), multilib=set()):
         """Adds an RPM to the set of module components."""
@@ -85,6 +126,8 @@ class ModuleComponents(object):
         component.multilib = multilib
         self._rpms[name] = component
 
+        self._save_to_libmodulemd()
+
     def del_rpm(self, s):
         """Removes the supplied RPM from the set of module components."""
         if not isinstance(s, str):
@@ -92,10 +135,14 @@ class ModuleComponents(object):
         if s in self._rpms:
             del self._rpms[s]
 
+        self._save_to_libmodulemd()
+
     def clear_rpms(self):
         """Clear the RPM component dictionary."""
         self._rpms.clear()
 
+        self._save_to_libmodulemd()
+
     @property
     def modules(self):
         """A dictionary of module-type components in this module.  The keys are
@@ -112,6 +159,8 @@ class ModuleComponents(object):
                 raise TypeError("components.modules: data type not supported")
         self._modules = d
 
+        self._save_to_libmodulemd()
+
     def add_module(self, name, rationale, buildorder=0,
             repository="", ref=""):
         component = ModuleComponentModule(name, rationale)
@@ -120,6 +169,8 @@ class ModuleComponents(object):
         component.ref = ref
         self._modules[name] = component
 
+        self._save_to_libmodulemd()
+
     def del_module(self, s):
         """Removes the supplied module from the set of module components."""
         if not isinstance(s, str):
@@ -127,6 +178,10 @@ class ModuleComponents(object):
         if s in self._modules:
             del self._modules[s]
 
+        self._save_to_libmodulemd()
+
     def clear_modules(self):
         """Clear the module-type component dictionary."""
         self._modules.clear()
+
+        self._save_to_libmodulemd()

